diff -aruN --binary 14/plugins/editors/tinymce.php 15/plugins/editors/tinymce.php
--- 14/plugins/editors/tinymce.php	2009-07-30 21:02:22.000000000 +0200
+++ 15/plugins/editors/tinymce.php	2009-11-04 18:51:20.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: tinymce.php 12546 2009-07-23 11:03:33Z erdsiger $
+ * @version		$Id: tinymce.php 13338 2009-10-27 02:15:55Z ian $
  * @package		Joomla
  * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -50,10 +50,9 @@
 	 */
 	function onInit()
 	{
-		$mainframe = &JFactory::getApplication();
-
-		$language	=& JFactory::getLanguage();
-
+		$mainframe =&JFactory::getApplication();
+		$language =& JFactory::getLanguage();
+		JPlugin::loadLanguage('plg_editors_tinymce', JPATH_ADMINISTRATOR);
 		$mode = $this->params->get('mode','advanced');
 		$theme = array('simple' => 'simple','advanced' => 'advanced','extended' => 'advanced');
 		$skin = $this->params->get( 'skin', '0' );
@@ -72,17 +71,17 @@
 			default:
 				$skin = "skin : \"default\",";
 		}
-		$compressed			= $this->params->def( 'compressed', 0 );
+		$compressed			= $this->params->def('compressed', 0);
+		$cleanup_startup	= $this->params->def('cleanup_startup', 0);
+		$cleanup_save		= $this->params->def('cleanup_save', 2);
+		$entity_encoding	= $this->params->def('entity_encoding', 'raw');
 
-		$cleanup_startup	= $this->params->def( 'cleanup_startup', 0 );
-		$cleanup_save		= $this->params->def( 'cleanup_save', 2 );
-		$entity_encoding	= $this->params->def( 'entity_encoding', 'raw' );
-		if ( $cleanup_startup ) {
+		if ($cleanup_startup) {
 			$cleanup_startup = 'true';
 		} else {
 			$cleanup_startup = 'false';
 		}
-		switch ( $cleanup_save ) {
+		switch ($cleanup_save) {
 			case '0': /* Never clean up on save */
 				$cleanup = 'false';
 				break;
@@ -97,10 +96,10 @@
 				break;
 		}
 
-		$langMode			= $this->params->def( 'lang_mode', 0 );
-		$langPrefix			= $this->params->def( 'lang_code', 'en' );
+		$langMode	= $this->params->def('lang_mode', 0);
+		$langPrefix	= $this->params->def('lang_code', 'en');
 		if ($langMode) {
-			$langPrefix = substr( $language->getTag(), 0, strpos( $language->getTag(), '-' ) );
+			$langPrefix = substr($language->getTag(), 0, strpos( $language->getTag(), '-' ));
 		}
 		if ($language->isRTL()) {
 			$text_direction = 'rtl';
@@ -108,74 +107,90 @@
 			$text_direction = 'ltr';
 		}
 
-		$content_css		= $this->params->def( 'content_css', 1 );
-		$content_css_custom	= $this->params->def( 'content_css_custom', '' );
-		// loading of css file for `styles` dropdown
-		if ( $content_css_custom ) {
-			$content_css = 'content_css : "'. $content_css_custom .'", ';
-		}
-		else {
-			/*
-			 * Lets get the default template for the site application
-			 */
-			$db =& JFactory::getDBO();
-			$query = 'SELECT template'
-			. ' FROM #__templates_menu'
-			. ' WHERE client_id = 0'
-			. ' AND menuid = 0'
-			;
-			$db->setQuery( $query );
-			$template = $db->loadResult();
+		$use_content_css	= $this->params->def('content_css', 1);
+		$content_css_custom	= $this->params->def('content_css_custom', '');
 
-			if($content_css)
-			{
-				$file_path = JPATH_SITE .'/templates/'. $template .'/css/';
-			        // Try for site css
-			        $file_name = "template";
+		/*
+		 * Lets get the default template for the site application
+		 */
+		$db =& JFactory::getDBO();
+		$query = 'SELECT template'
+		. ' FROM #__templates_menu'
+		. ' WHERE client_id = 0'
+		. ' AND menuid = 0'
+		;
+		$db->setQuery( $query );
+		$template = $db->loadResult();
+
+		$content_css = '';
+
+		$templates_path = JPATH_SITE.DS.'templates';
+		// loading of css file for 'styles' dropdown
+		if ( $content_css_custom )
+		{
+			// If URL, just pass it to $content_css
+			if (strpos( $content_css_custom, 'http' ) !==false) {
+				$content_css = 'content_css : "'. $content_css_custom .'",';
+			// If it is not a URL, assume it is a file name in the current template folder
+			} else {
+				$content_css = 'content_css : "'. JURI::root() .'templates/'. $template . '/css/'. $content_css_custom .'",';
 
-			        if ($language->isRTL()) {
-					$file_name .= "_rtl.css";
-				} else {
-					$file_name .= ".css";
+				// Issue warning notice if the file is not found (but pass name to $content_css anyway to avoid TinyMCE error
+				if (!file_exists($templates_path.DS.$template.DS.'css'.DS.$content_css_custom)) {
+					$msg = sprintf (JText::_('CUSTOMCSSFILENOTPRESENT'), $content_css_custom);
+					JError::raiseNotice('SOME_ERROR_CODE', $msg);
 				}
+			}
+		}
+		else
+		{
+			// process when use_content_css is Yes and no custom file given
+			if($use_content_css) {
 
-				if ( file_exists( $file_path .DS. $file_name ) ) {
-					$content_css = 'content_css : "' . JURI::root() .'templates/'. $template . '/css/'.$file_name.', ' . JURI::root() .'templates/system/css/editor.css"';
+				// first check templates folder for default template
+				// if no editor.css file in templates folder, check system template folder
+				if (!file_exists($templates_path.DS.$template.DS.'css'.DS.'editor.css')) {
+					$template = 'system';
+
+					// if no editor.css file in system folder, show alert
+					if (!file_exists($templates_path.DS.'system'.DS.'css'.DS.'editor.css'))
+					{
+						JError::raiseNotice('SOME_ERROR_CODE', JText::_('TEMPLATECSSFILENOTPRESENT'));
+					} else {
+						$content_css = 'content_css : "' . JURI::root() .'templates/system/css/editor.css",';
+					}
 				} else {
-					$content_css = 'content_css : "' . JURI::root() .'templates/system/css/editor.css"';
+					$content_css = 'content_css : "' . JURI::root() .'templates/'. $template . '/css/editor.css",';
 				}
-			} else {
-				$content_css = '';
 			}
 		}
 
-		$relative_urls		= $this->params->def( 'relative_urls', '1' );
+		$relative_urls		= $this->params->def('relative_urls', '1');
 		if ( $relative_urls ) { // relative
 			$relative_urls = "true";
 		} else { // absolute
 			$relative_urls = "false";
 		}
 
-		$newlines = $this->params->def( 'newlines', 0 );
-		if ( $newlines ) { // br
-			$forcenewline = "force_br_newlines : \"true\", force_p_newlines : \"false\", forced_root_block : '',";
+		$newlines = $this->params->def('newlines', 0);
+		if ($newlines) { // br
+			$forcenewline = "force_br_newlines : true, force_p_newlines : false, forced_root_block : '',";
 		} else { // p
-			$forcenewline = "force_br_newlines : \"false\", force_p_newlines : \"true\", forced_root_block : 'p',";
+			$forcenewline = "force_br_newlines : false, force_p_newlines : true, forced_root_block : 'p',";
 		}
-		$invalid_elements	= $this->params->def( 'invalid_elements', 'script,applet,iframe' );
-		$extended_elements	= $this->params->def( 'extended_elements', '' );
-
+		$invalid_elements	= $this->params->def('invalid_elements', 'script,applet,iframe');
+		$extended_elements	= $this->params->def('extended_elements', '');
 
 		// theme_advanced_* settings
-		$toolbar = $this->params->def( 'toolbar', 'top' );
-		$toolbar_align	= $this->params->def( 'toolbar_align', 'left' );
-		$html_height = $this->params->def( 'html_height', '550' );
-		$html_width = $this->params->def( 'html_width', '750' );
+		$toolbar = $this->params->def('toolbar', 'top');
+		$toolbar_align	= $this->params->def('toolbar_align', 'left');
+		$html_height = $this->params->def('html_height', '550');
+		$html_width = $this->params->def('html_width', '750');
 		$element_path = '';
 		if ($this->params->get('element_path', 1)) {
-			$element_path = "theme_advanced_statusbar_location : \"bottom\", theme_advanced_path : true";
+			$element_path = 'theme_advanced_statusbar_location : "bottom", theme_advanced_path : true';
 		} else {
-			$element_path = "theme_advanced_statusbar_location : \"none\", theme_advanced_path : false";
+			$element_path = 'theme_advanced_statusbar_location : "none", theme_advanced_path : false';
 		}
 
 		$buttons1_add_before = $buttons1_add = array();
@@ -183,103 +198,105 @@
 		$buttons3_add_before = $buttons3_add = array();
 		$buttons4 = array();
 		$plugins 	= array();
-		if( $extended_elements != "" ) $elements = explode( ',', $extended_elements );
+		if($extended_elements != "") $elements = explode(',', $extended_elements);
 
 		//Initial values for buttons
-		array_push($buttons2_add_before,'cut','copy','paste');
-		array_push($buttons2_add,'|');
+		array_push($buttons4,'cut','copy','paste');
+		//array_push($buttons4,'|');
 
 		// Plugins
 
 		// fonts
 		$fonts =  $this->params->def( 'fonts', 1 );
-		if ( $fonts ) {
+		if ($fonts) {
 			$buttons1_add[]	= 'fontselect,fontsizeselect';
 		}
 
 		// paste
-		$paste =  $this->params->def( 'paste', 1 );
-		if ( $paste ) {
+		$paste =  $this->params->def('paste', 1);
+		if ($paste) {
 			$plugins[]	= 'paste';
-			$buttons2_add_before[]	= 'pastetext,pasteword,selectall';
+			$buttons4[]	= 'pastetext';
+			$buttons4[]	= 'pasteword';
+			$buttons4[]	= 'selectall,|';
 		}
 
 		// search & replace
-		$searchreplace 		=  $this->params->def( 'searchreplace', 1 );
-		if ( $searchreplace ) {
+		$searchreplace		=  $this->params->def('searchreplace', 1);
+		if ($searchreplace) {
 			$plugins[]	= 'searchreplace';
-			$buttons2_add_before[]	= '|,search,replace,|';
+			$buttons2_add_before[]	= 'search,replace,|';
 		}
 
 		// insert date and/or time plugin
-		$insertdate			= $this->params->def( 'insertdate', 1 );
-		$format_date		= $this->params->def( 'format_date', '%Y-%m-%d' );
-		$inserttime			= $this->params->def( 'inserttime', 1 );
-		$format_time		= $this->params->def( 'format_time', '%H:%M:%S' );
-		if ( $insertdate or $inserttime ) {
+		$insertdate			= $this->params->def('insertdate', 1);
+		$format_date		= $this->params->def('format_date', '%Y-%m-%d');
+		$inserttime			= $this->params->def('inserttime', 1);
+		$format_time		= $this->params->def('format_time', '%H:%M:%S');
+		if ($insertdate or $inserttime) {
 			$plugins[]	= 'insertdatetime';
-			if ( $insertdate ) {
+			if ($insertdate) {
 				$buttons2_add[]	= 'insertdate';
 			}
-			if ( $inserttime ) {
+			if ($inserttime) {
 				$buttons2_add[]	= 'inserttime';
 			}
 		}
 
 		// colors
-		$colors =  $this->params->def( 'colors', 1 );
-		if ( $colors ) {
+		$colors =  $this->params->def('colors', 1);
+		if ($colors) {
 			$buttons2_add[]	= 'forecolor,backcolor';
 		}
 
 		// table
-		$table = $this->params->def( 'table', 1 );
-		if ( $table ) {
+		$table = $this->params->def('table', 1);
+		if ($table) {
 			$plugins[]	= 'table';
 			$buttons3_add_before[]	= 'tablecontrols';
 		}
 
 		// emotions
-		$smilies = $this->params->def( 'smilies', 1 );
-		if ( $smilies ) {
+		$smilies = $this->params->def('smilies', 1);
+		if ($smilies) {
 			$plugins[]	= 'emotions';
 			$buttons3_add[]	= 'emotions';
 		}
 
-		//media plugin 
-		$media = $this->params->def( 'media', 1 );
-		if ( $media ) {
+		//media plugin
+		$media = $this->params->def('media', 1);
+		if ($media) {
 			$plugins[] = 'media';
 			$buttons3_add[] = 'media';
 		}
 
 		// horizontal line
-		$hr = $this->params->def( 'hr', 1 );
-		if ( $hr ) {
+		$hr = $this->params->def('hr', 1);
+		if ($hr) {
 			$plugins[]	= 'advhr';
-			$elements[] = 'hr[id|title|alt|class|width|size|noshade]';
+			$elements[] = 'hr[id|title|alt|class|width|size|noshade|style]';
 			$buttons3_add[]	= 'advhr';
 		} else {
 			$elements[] = 'hr[id|class|title|alt]';
 		}
 
 		// rtl/ltr buttons
-		$directionality	= $this->params->def( 'directionality', 1 );
-		if ( $directionality ) {
+		$directionality	= $this->params->def('directionality', 1);
+		if ($directionality) {
 			$plugins[] = 'directionality';
 			$buttons3_add[] = 'ltr,rtl';
 		}
 
 		// fullscreen
-		$fullscreen	= $this->params->def( 'fullscreen', 1 );
-		if ( $fullscreen ) {
+		$fullscreen	= $this->params->def('fullscreen', 1);
+		if ($fullscreen) {
 			$plugins[]	= 'fullscreen';
-			$buttons3_add[]	= 'fullscreen';
+			$buttons2_add[]	= 'fullscreen';
 		}
 
 		// layer
-		$layer = $this->params->def( 'layer', 1 );
-		if ( $layer ) {
+		$layer = $this->params->def('layer', 1);
+		if ($layer) {
 			$plugins[]	= 'layer';
 			$buttons4[]	= 'insertlayer';
 			$buttons4[]	= 'moveforward';
@@ -288,69 +305,76 @@
 		}
 
 		// style
-		$style			= $this->params->def( 'style', 1 );
-		if ( $style ) {
+		$style = $this->params->def('style', 1);
+		if ($style) {
 			$plugins[]	= 'style';
 			$buttons4[]	= 'styleprops';
 		}
 
 		// XHTMLxtras
-		$xhtmlxtras			= $this->params->def( 'xhtmlxtras', 1 );
-		if ( $xhtmlxtras ) {
+		$xhtmlxtras	= $this->params->def('xhtmlxtras', 1);
+		if ($xhtmlxtras) {
 			$plugins[]	= 'xhtmlxtras';
 			$buttons4[]	= 'cite,abbr,acronym,ins,del,attribs';
 		}
 
 		// visualchars
-		$visualchars = $this->params->def( 'visualchars', 1 );
-		if ( $template ) {
+		$visualchars = $this->params->def('visualchars', 1);
+		if ($visualchars) {
 			$plugins[]	= 'visualchars';
 			$buttons4[]	= 'visualchars';
 		}
 
-		// visualchars
-		$nonbreaking = $this->params->def( 'nonbreaking', 1 );
-		if ( $template ) {
+		// non-breaking
+		$nonbreaking = $this->params->def('nonbreaking', 1);
+		if ($nonbreaking) {
 			$plugins[]	= 'nonbreaking';
 			$buttons4[]	= 'nonbreaking';
 		}
 
+		// blockquote
+		$blockquote	= $this->params->def( 'blockquote', 1 );
+		if ( $blockquote ) {
+			$plugins[] = 'blockquote';
+			$buttons4[] = 'blockquote';
+		}
+
 		// template
-		$template = $this->params->def( 'template', 1 );
-		if ( $template ) {
+		$template = $this->params->def('template', 1);
+		if ($template) {
 			$plugins[]	= 'template';
 			$buttons4[]	= 'template';
 		}
 
 		// advimage
-		$advimage = $this->params->def( 'advimage', 1 );
-		if ( $advimage ) {
+		$advimage = $this->params->def('advimage', 1);
+		if ($advimage) {
 			$plugins[]	= 'advimage';
-			$elements[]	= 'img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name]';
+			$elements[]	= 'img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name|style]';
 		}
 
 		// advlink
-		$advlink 	= $this->params->def( 'advlink', 1 );
-		if ( $advlink ) {
+		$advlink 	= $this->params->def('advlink', 1);
+		if ($advlink) {
 			$plugins[]	= 'advlink';
-			$elements[]	= 'a[class|name|href|target|title|onclick|rel]';
+			$elements[]	= 'a[class|name|href|target|title|onclick|rel|style]';
 		}
 
 		// autosave
-		$autosave			= $this->params->def( 'autosave', 1 );
-		if ( $autosave ) {
+		$autosave = $this->params->def('autosave', 1);
+		if ($autosave) {
 			$plugins[]	= 'autosave';
 		}
 
 		// context menu
-		$contextmenu	= $this->params->def( 'contextmenu', 1 );
-		if ( $contextmenu ) {
+		$contextmenu = $this->params->def('contextmenu', 1);
+		if ($contextmenu) {
 			$plugins[]	= 'contextmenu';
 		}
 
 		// inline popups
-		$inlinepopups			= $this->params->def( 'inlinepopups', 1 );
-		if ( $inlinepopups ) {
+		$inlinepopups			= $this->params->def('inlinepopups', 1);
+		if ($inlinepopups) {
 			$plugins[]	= 'inlinepopups';
 			$dialog_type = "dialog_type : \"modal\",";
 		} else {
@@ -358,171 +382,191 @@
 		}
 
 		// Safari compatibility
-		$safari			= $this->params->def( 'safari', 0 );
-		if ( $safari ) {
+		$safari	= $this->params->def('safari', 0);
+		if ($safari) {
 			$plugins[]	= 'safari';
 		}
 
-		$custom_plugin = $this->params->def( 'custom_plugin', '' );
+		$custom_plugin = $this->params->def('custom_plugin', '');
 		if ($custom_plugin != "") {
 			$plugins[] = $custom_plugin;
 		}
 
-		$custom_button = $this->params->def( 'custom_button', '' );
+		$custom_button = $this->params->def('custom_button', '');
 		if ($custom_button != "") {
 			$buttons4[] = $custom_button;
 		}
 
 		// Prepare config variables
-		$buttons1_add_before 	= implode( ',', $buttons1_add_before );
-		$buttons2_add_before 	= implode( ',', $buttons2_add_before );
-		$buttons3_add_before 	= implode( ',', $buttons3_add_before );
-		$buttons1_add 	= implode( ',', $buttons1_add );
-		$buttons2_add 	= implode( ',', $buttons2_add );
-		$buttons3_add 	= implode( ',', $buttons3_add );
-		$buttons4 	= implode( ',', $buttons4 );
-		$plugins		= implode( ',', $plugins );
-		$elements 	= implode( ',', $elements );
+		$buttons1_add_before = implode(',', $buttons1_add_before);
+		$buttons2_add_before = implode(',', $buttons2_add_before);
+		$buttons3_add_before = implode(',', $buttons3_add_before);
+		$buttons1_add = implode(',', $buttons1_add);
+		$buttons2_add = implode(',', $buttons2_add);
+		$buttons3_add = implode(',', $buttons3_add);
+		$buttons4 = implode(',', $buttons4);
+		$plugins = implode(',', $plugins);
+		$elements = implode(',', $elements);
 
 		switch($mode) {
-		case 'simple': /* Simple mode*/
-			if ($compressed) {
-				$load = "\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js\"></script>\n";
-				$load .= "\t<script type=\"text/javascript\">
+			case 'simple': /* Simple mode*/
+				if ($compressed) {
+					$load = "\t<script type=\"text/javascript\" src=\"".
+							JURI::root().
+							"plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js\"></script>\n";
+					$load .= "\t<script type=\"text/javascript\">
 					tinyMCE_GZ.init({
 					themes : \"$theme[$mode]\",
 					languages : \"". $langPrefix . "\"
 				});
 				</script>";
-			} else {
-				$load = "\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce.js\"></script>\n";
-			}
-			$return = $load .
+				} else {
+					$load = "\t<script type=\"text/javascript\" src=\"".
+							JURI::root().
+							"plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce.js\"></script>\n";
+				}
+				$return = $load .
 				"\t<script type=\"text/javascript\">
 				tinyMCE.init({
-				// General
-				directionality: \"$text_direction\",
-				editor_selector : \"mce_editable\",
-				language : \"". $langPrefix . "\",
-				mode : \"specific_textareas\",
-				$skin
-				theme : \"$theme[$mode]\",
-				// Cleanup/Output
-				cleanup : $cleanup,
-				cleanup_on_startup : $cleanup_startup,
-				entity_encoding : \"$entity_encoding\",
-				$forcenewline
-				// URL
-				relative_urls : $relative_urls,
-				remove_script_host : false,
-				document_base_url : \"". JURI::root() ."\",
-				// Layout
-				$content_css
+					// General
+					directionality: \"$text_direction\",
+					editor_selector : \"mce_editable\",
+					language : \"". $langPrefix . "\",
+					mode : \"specific_textareas\",
+					$skin
+					theme : \"$theme[$mode]\",
+					// Cleanup/Output
+					inline_styles : true,
+					gecko_spellcheck : true,
+					cleanup : $cleanup,
+					cleanup_on_startup : $cleanup_startup,
+					entity_encoding : \"$entity_encoding\",
+					$forcenewline
+					// URL
+					relative_urls : $relative_urls,
+					remove_script_host : false,
+					// Layout
+					$content_css
+					document_base_url : \"". JURI::root() ."\",
 				});
 				</script>";
-		  break;
+				break;
 
-		case 'advanced': /* Advanced mode*/
-		  if ($compressed) {
-			$load = "\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js\"></script>\n";
-			$load .= "\t<script type=\"text/javascript\">
-	      tinyMCE_GZ.init({
-				themes : \"$theme[$mode]\",
-				languages : \"". $langPrefix . "\"
-				});
+			case 'advanced': /* Advanced mode*/
+				if ($compressed) {
+					$load = "\t<script type=\"text/javascript\" src=\"".
+							JURI::root().
+							"plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js\"></script>\n";
+					$load .= "\t<script type=\"text/javascript\">
+						tinyMCE_GZ.init({
+						themes : \"$theme[$mode]\",
+						languages : \"". $langPrefix . "\"
+					});
 				</script>";
-		} else {
-				$load = "\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce.js\"></script>\n";
-			}
-			$return = $load .
+				} else {
+					$load = "\t<script type=\"text/javascript\" src=\"".
+							JURI::root().
+							"plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce.js\"></script>\n";
+				}
+				$return = $load .
 				"\t<script type=\"text/javascript\">
 				tinyMCE.init({
-				// General
-				directionality: \"$text_direction\",
-				editor_selector : \"mce_editable\",
-				language : \"". $langPrefix . "\",
-				mode : \"specific_textareas\",
-				$skin
-				theme : \"$theme[$mode]\",
-				// Cleanup/Output
-				cleanup : $cleanup,
-				cleanup_on_startup : $cleanup_startup,
-				entity_encoding : \"$entity_encoding\",
-				extended_valid_elements : \"$elements\",
-				$forcenewline
-				invalid_elements : \"$invalid_elements\",
-				// URL
-				relative_urls : $relative_urls,
-				remove_script_host : false,
-				document_base_url : \"". JURI::root() ."\",
-				// Layout
-				$content_css,
-				// Advanced theme
-				theme_advanced_toolbar_location : \"$toolbar\",
-				theme_advanced_toolbar_align : \"$toolbar_align\",
-				theme_advanced_source_editor_height : \"$html_height\",
-				theme_advanced_source_editor_width : \"$html_width\",
-				$element_path
+					// General
+					directionality: \"$text_direction\",
+					editor_selector : \"mce_editable\",
+					language : \"". $langPrefix . "\",
+					mode : \"specific_textareas\",
+					$skin
+					theme : \"$theme[$mode]\",
+					// Cleanup/Output
+					inline_styles : true,
+					gecko_spellcheck : true,
+					cleanup : $cleanup,
+					cleanup_on_startup : $cleanup_startup,
+					entity_encoding : \"$entity_encoding\",
+					extended_valid_elements : \"$elements\",
+					$forcenewline
+					invalid_elements : \"$invalid_elements\",
+					// URL
+					relative_urls : $relative_urls,
+					remove_script_host : false,
+					document_base_url : \"". JURI::root() ."\",
+					// Layout
+					$content_css
+					// Advanced theme
+					theme_advanced_toolbar_location : \"$toolbar\",
+					theme_advanced_toolbar_align : \"$toolbar_align\",
+					theme_advanced_source_editor_height : \"$html_height\",
+					theme_advanced_source_editor_width : \"$html_width\",
+					$element_path
 				});
 				</script>";
-		  break;
+				break;
 
-		case 'extended': /* Extended mode*/
-		  if ($compressed) {
-		    $load = "\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js\"></script>\n";
-				$load .= "\t<script type=\"text/javascript\">
-	      tinyMCE_GZ.init({
-				themes : \"$theme[$mode]\",
-				plugins : \"$plugins\",
-				languages : \"". $langPrefix . "\"
+			case 'extended': /* Extended mode*/
+				if ($compressed) {
+					$load = "\t<script type=\"text/javascript\" src=\"".
+							JURI::root().
+							"plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce_gzip.js\"></script>\n";
+				  	$load .= "\t<script type=\"text/javascript\">
+				tinyMCE_GZ.init({
+					themes : \"$theme[$mode]\",
+					plugins : \"$plugins\",
+					languages : \"". $langPrefix . "\"
 				});
 				</script>";
-			} else {
-				$load = "\t<script type=\"text/javascript\" src=\"".JURI::root()."plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce.js\"></script>\n";
-			}
-			$return = $load .
+		  } else {
+				$load = "\t<script type=\"text/javascript\" src=\"".
+						JURI::root().
+						"plugins/editors/tinymce/jscripts/tiny_mce/tiny_mce.js\"></script>\n";
+		  }
+		  $return = $load .
 				"\t<script type=\"text/javascript\">
 				tinyMCE.init({
-				// General
-				$dialog_type
-				directionality: \"$text_direction\",
-				editor_selector : \"mce_editable\",
-				language : \"". $langPrefix . "\",
-				mode : \"specific_textareas\",
-				plugins : \"$plugins\",
-				$skin
-				theme : \"$theme[$mode]\",
-				// Cleanup/Output
-				cleanup : $cleanup,
-				cleanup_on_startup : $cleanup_startup,
-				entity_encoding : \"$entity_encoding\",
-				extended_valid_elements : \"$elements\",
-				$forcenewline
-				invalid_elements : \"$invalid_elements\",
-				// URL
-				relative_urls : $relative_urls,
-				remove_script_host : false,
-				document_base_url : \"". JURI::root() ."\",
-				// Layout
-				$content_css,
-				// Advanced theme
-				theme_advanced_toolbar_location : \"$toolbar\",
-				theme_advanced_toolbar_align : \"$toolbar_align\",
-				theme_advanced_source_editor_height : \"$html_height\",
-				theme_advanced_source_editor_width : \"$html_width\",
-				$element_path,
-				theme_advanced_buttons1_add_before : \"$buttons1_add_before\",
-				theme_advanced_buttons2_add_before : \"$buttons2_add_before\",
-				theme_advanced_buttons3_add_before : \"$buttons3_add_before\",
-				theme_advanced_buttons1_add : \"$buttons1_add\",
-				theme_advanced_buttons2_add : \"$buttons2_add\",
-				theme_advanced_buttons3_add : \"$buttons3_add\",
-				theme_advanced_buttons4 : \"$buttons4\",
-				plugin_insertdate_dateFormat : \"$format_date\",
-				plugin_insertdate_timeFormat : \"$format_time\",
-				fullscreen_settings : {
-				theme_advanced_path_location : \"top\"
-				}
+					// General
+					$dialog_type
+					directionality: \"$text_direction\",
+					editor_selector : \"mce_editable\",
+					language : \"". $langPrefix . "\",
+					mode : \"specific_textareas\",
+					plugins : \"$plugins\",
+					$skin
+					theme : \"$theme[$mode]\",
+					// Cleanup/Output
+					inline_styles : true,
+					gecko_spellcheck : true,
+					cleanup : $cleanup,
+					cleanup_on_startup : $cleanup_startup,
+					entity_encoding : \"$entity_encoding\",
+					extended_valid_elements : \"$elements\",
+					$forcenewline
+					invalid_elements : \"$invalid_elements\",
+					// URL
+					relative_urls : $relative_urls,
+					remove_script_host : false,
+					document_base_url : \"". JURI::root() ."\",
+					//Templates
+					template_external_list_url :  \"". JURI::root() ."plugins/editors/tinymce/templates/template_list.js\",
+					// Layout
+					$content_css
+					// Advanced theme
+					theme_advanced_toolbar_location : \"$toolbar\",
+					theme_advanced_toolbar_align : \"$toolbar_align\",
+					theme_advanced_source_editor_height : \"$html_height\",
+					theme_advanced_source_editor_width : \"$html_width\",
+					$element_path,
+					theme_advanced_buttons1_add_before : \"$buttons1_add_before\",
+					theme_advanced_buttons2_add_before : \"$buttons2_add_before\",
+					theme_advanced_buttons3_add_before : \"$buttons3_add_before\",
+					theme_advanced_buttons1_add : \"$buttons1_add\",
+					theme_advanced_buttons2_add : \"$buttons2_add\",
+					theme_advanced_buttons3_add : \"$buttons3_add\",
+					theme_advanced_buttons4 : \"$buttons4\",
+					plugin_insertdate_dateFormat : \"$format_date\",
+					plugin_insertdate_timeFormat : \"$format_time\",
+					fullscreen_settings : {
+						theme_advanced_path_location : \"top\"
+					}
 				});
 				</script>";
 		  break;
@@ -537,7 +581,7 @@
 	 * @param string 	The name of the editor
 	 */
 	function onGetContent( $editor ) {
-		return "tinyMCE.activeEditor.getContent();";
+		return 'tinyMCE.get(\''.$editor.'\').getContent();';
 	}
 
 	/**
@@ -545,8 +589,8 @@
 	 *
 	 * @param string 	The name of the editor
 	 */
-	function onSetContent( $editor, $html ) {
-		return "tinyMCE.activeEditor.setContent(".$html.");";
+	function onSetContent($editor, $html) {
+		return 'tinyMCE.get(\''.$editor.'\').setContent('.$html.');';
 	}
 
 	/**
@@ -554,8 +598,8 @@
 	 *
 	 * @param string 	The name of the editor
 	 */
-	function onSave( $editor ) {
-		return "tinyMCE.triggerSave();";
+	function onSave($editor) {
+ 		return 'if (tinyMCE.get("'.$editor.'").isHidden()) {tinyMCE.get("'.$editor.'").show()}; tinyMCE.get("'.$editor.'").save();';
 	}
 
 	/**
@@ -569,7 +613,7 @@
 	 * @param int The number of rows for the editor area
 	 * @param mixed Can be boolean or array.
 	 */
-	function onDisplay( $name, $content, $width, $height, $col, $row, $buttons = true)
+	function onDisplay($name, $content, $width, $height, $col, $row, $buttons = true)
 	{
 		// Only add "px" to width and height if they are not given as a percentage
 		if (is_numeric( $width )) {
@@ -580,19 +624,40 @@
 		}
 
 		$editor  = "<textarea id=\"$name\" name=\"$name\" cols=\"$col\" rows=\"$row\" style=\"width:{$width}; height:{$height};\" class=\"mce_editable\">$content</textarea>\n" .
-		$this->_displayButtons($name, $buttons) .
-		$this->_toogleButton($name);
+			$this->_displayButtons($name, $buttons) .
+			$this->_toogleButton($name);
 
 		return $editor;
 	}
 
 	function onGetInsertMethod($name)
 	{
-		$doc = & JFactory::getDocument();
+		$doc =& JFactory::getDocument();
+
+		$js= "
+			function isBrowserIE() {
+				return navigator.appName==\"Microsoft Internet Explorer\";
+			}
+
+			function jInsertEditorText( text, editor ) {
+				if (isBrowserIE()) {
+					if (window.parent.tinyMCE) {
+						window.parent.tinyMCE.selectedInstance.selection.moveToBookmark(window.parent.global_ie_bookmark);
+					}
+				}
+				tinyMCE.execInstanceCommand(editor, 'mceInsertContent',false,text);
+			}
+
+			var global_ie_bookmark = false;
+
+			function IeCursorFix() {
+				if (isBrowserIE()) {
+					tinyMCE.execCommand('mceInsertContent', false, '');
+					global_ie_bookmark = tinyMCE.activeEditor.selection.getBookmark(false);
+				}
+				return true;
+			}";
 
-		$js= "function jInsertEditorText( text, editor ) {
-			tinyMCE.execInstanceCommand(editor, 'mceInsertContent',false,text);
-		}";
 		$doc->addScriptDeclaration($js);
 
 		return true;
@@ -631,7 +696,7 @@
 				{
 					$modal		= ($button->get('modal')) ? 'class="modal-button"' : null;
 					$href		= ($button->get('link')) ? 'href="'.JURI::base().$button->get('link').'"' : null;
-					$onclick	= ($button->get('onclick')) ? 'onclick="'.$button->get('onclick').'"' : null;
+                    $onclick	= ($button->get('onclick')) ? 'onclick="'.$button->get('onclick').'"' : 'onclick="IeCursorFix(); return false;"';
 					$return .= "<div class=\"button2-left\"><div class=\"".$button->get('name')."\"><a ".$modal." title=\"".$button->get('text')."\" ".$href." ".$onclick." rel=\"".$button->get('options')."\">".$button->get('text')."</a></div></div>\n";
 				}
 			}
diff -aruN --binary 14/plugins/search/content.php 15/plugins/search/content.php
--- 14/plugins/search/content.php	2009-05-29 14:52:00.000000000 +0200
+++ 15/plugins/search/content.php	2009-11-04 18:51:20.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: content.php 11371 2008-12-30 01:31:50Z ian $
+ * @version		$Id: content.php 12697 2009-09-12 02:10:36Z ian $
  * @package		Joomla
  * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -178,7 +178,7 @@
 	{
 		$query = 'SELECT id, a.title AS title, a.created AS created, a.metadesc, a.metakey, '
 		. ' CONCAT(a.introtext, a.fulltext) AS text,'
-		. ' "2" as browsernav, "'. $db->Quote(JText::_('Uncategorised Content')) .'" AS section'
+		. ' "2" as browsernav, "'. $db->getEscaped(JText::_('Uncategorised Content')) .'" AS section'
 		. ' FROM #__content AS a'
 		. ' WHERE ('.$where.')'
 		. ' AND a.state = 1'
